package com.me.brickbuster.state;

import com.badlogic.gdx.ScreenAdapter;
import com.me.brickbuster.BrickBuster;

public abstract class State extends ScreenAdapter {

	protected final BrickBuster game;
	private boolean disposed;

	public State(BrickBuster game) {
		this.game = game;
		this.setup();
	}

	@Override
	public final void render(float delta) {
		update(delta);
		if (!disposed) {
			render();
		}
	}

	@Override
	public void dispose() {
		this.disposed = true;
	}

	public BrickBuster getGame() {
		return game;
	}

	public abstract void setup();

	public abstract void render();

	public abstract void update(float dt);

}
